%
%                            Copyright 2011 Zilmar de Souza Junior,
%						                    Marcos Moecke 
%
%
%
%    ModulacoesDigitais is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    ModulacoesDigitais is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with ModulacoesDigitais. If not, see <http://www.gnu.org/licenses/>.
%

function varargout = ModulacoesDigitais(varargin)
% MODULACOESDIGITAIS M-file for ModulacoesDigitais.fig
%      MODULACOESDIGITAIS, by itself, creates a new MODULACOESDIGITAIS or raises the existing
%      singleton*.
%
%      H = MODULACOESDIGITAIS returns the handle to a new MODULACOESDIGITAIS or the handle to
%      the existing singleton*.
%
%      MODULACOESDIGITAIS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MODULACOESDIGITAIS.M with the given input arguments.
%
%      MODULACOESDIGITAIS('Property','Value',...) creates a new MODULACOESDIGITAIS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ModulacoesDigitais_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ModulacoesDigitais_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ModulacoesDigitais

% Last Modified by GUIDE v2.5 06-Oct-2014 22:15:44

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @ModulacoesDigitais_OpeningFcn, ...
    'gui_OutputFcn',  @ModulacoesDigitais_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ModulacoesDigitais is made visible.
function ModulacoesDigitais_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ModulacoesDigitais (see VARARGIN)

% Choose default command line output for ModulacoesDigitais
handles.output = hObject;
set(handles.radiobutton_mapeamentoGray,'enable','on')
set(handles.radiobutton_mapeamentoPadrao,'enable','on')

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ModulacoesDigitais wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ModulacoesDigitais_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popupmenuModulacao.
function popupmenuModulacao_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuModulacao (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenuModulacao contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuModulacao
modulacao = get(hObject,'Value');
handles.metricdata.modulacao = modulacao;
if get(hObject,'Value')==2
    set(handles.radiobutton_mapeamentoGray,'enable','off')
    set(handles.radiobutton_mapeamentoPadrao,'enable','off')
else
    set(handles.radiobutton_mapeamentoGray,'enable','on')
    set(handles.radiobutton_mapeamentoPadrao,'enable','on')
end
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function popupmenuModulacao_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuModulacao (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonPlotar.
function pushbuttonPlotar_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonPlotar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.metricdata.modulacao = get(handles.popupmenuModulacao,'Value');
handles.metricdata.M = str2double(get(handles.M,'String'));
handles.metricdata.editSequencia = get(handles.editSequenciaManual,'String');
handles.metricdata.numBits = str2double(get(handles.editNumBits,'String'));
handles.metricdata.taxadeBits = str2double(get(handles.c_taxadeBits,'String'));
handles.metricdata.c_fp = str2double(get(handles.c_fp,'String'));
handles.metricdata.mapeamento = get(handles.radiobutton_mapeamentoGray,'value');
Atualiza_Interface_Modulacoes_Digitais(handles)
guidata(hObject,handles)



function editSequenciaManual_Callback(hObject, eventdata, handles)
% hObject    handle to editSequenciaManual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editSequenciaManual as text
%        str2double(get(hObject,'String')) returns contents of editSequenciaManual as a double
handles.metricdata.editSequencia = get(hObject,'String');
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function editSequenciaManual_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editSequenciaManual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in checkboxManterBits.
function checkboxManterBits_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxManterBits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxManterBits


% --- Executes on button press in radiobuttonManual.
function radiobuttonManual_Callback(hObject, eventdata, handles)
% hObject    handle to radiobuttonManual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobuttonManual
set(handles.editSequenciaManual,'Enable','on');
%set(handles.radiobuttonAleatoria,'')
set(handles.checkboxManterBits,'Enable','off');


% --- Executes on button press in radiobuttonAleatoria.
function radiobuttonAleatoria_Callback(hObject, eventdata, handles)
% hObject    handle to radiobuttonAleatoria (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobuttonAleatoria
set(handles.editSequenciaManual,'Enable','off');
set(handles.checkboxManterBits,'Enable','on');


% --- Executes on button press in checkboxConstelacao.
function checkboxConstelacao_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxConstelacao (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.metricdata.Constelacao=1;
guidata(hObject,handles)

% --------------------------------------------------------------------
function zoomx_OffCallback(hObject, eventdata, handles)
% hObject    handle to zoomx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom on;

% --------------------------------------------------------------------
function zoomx_OnCallback(hObject, eventdata, handles)
% hObject    handle to zoomx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom xon;

function zoomx_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to zoomx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function zoomy_OffCallback(hObject, eventdata, handles)
% hObject    handle to zoomy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom on;

% --------------------------------------------------------------------
function zoomy_OnCallback(hObject, eventdata, handles)
% hObject    handle to zoomy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom yon;



function M_Callback(hObject, eventdata, handles)
% hObject    handle to M (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of M as text
%        str2double(get(hObject,'String')) returns contents of M as a double
M=get(handles.M, 'Value');
handles.metricdata.M=M;
guidata(hObject,handles)
key = get(gcf,'CurrentKey');
if(strcmp (key , 'enter'))
    pushbuttonPlotar_Callback(handles.pushbuttonPlotar, eventdata, handles);
end


% --- Executes during object creation, after setting all properties.
function M_CreateFcn(hObject, eventdata, handles)
% hObject    handle to M (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editNumBits_Callback(hObject, eventdata, handles)
% hObject    handle to editNumBits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editNumBits as text
%        str2double(get(hObject,'String')) returns contents of editNumBits as a double
handles.metricdata.numBits = str2double(get(hObject,'String'));
guidata(hObject,handles)
pushbuttonPlotar_Callback(handles.pushbuttonPlotar, eventdata, handles);

% --- Executes during object creation, after setting all properties.
function editNumBits_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editNumBits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkboxMostrarFreq.
function checkboxMostrarFreq_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxMostrarFreq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxMostrarFreq


% --- Executes on button press in checkboxMostrarFase.
function checkboxMostrarFase_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxMostrarFase (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxMostrarFase


% --- Executes on button press in checkboxCalcularMedia.
function checkboxCalcularMedia_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxCalcularMedia (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of checkboxCalcularMedia
global sinal_m;
global count_m;
count_m=0;
sinal_m=[];



function c_taxadeBits_Callback(hObject, eventdata, handles)
% hObject    handle to c_taxadeBits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_taxadeBits as text
%        str2double(get(hObject,'String')) returns contents of c_taxadeBits as a double
handles.metricdata.taxadeBits = str2double(get(hObject,'String'));
guidata(hObject,handles)
pushbuttonPlotar_Callback(handles.pushbuttonPlotar, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function c_taxadeBits_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_taxadeBits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function c_fp_Callback(hObject, eventdata, handles)
% hObject    handle to c_fp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_fp as text
%        str2double(get(hObject,'String')) returns contents of c_fp as a double
handles.metricdata.c_fp = str2double(get(hObject,'String'));
guidata(hObject,handles)
pushbuttonPlotar_Callback(handles.pushbuttonPlotar, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function c_fp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_fp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in radiobutton_mapeamentoGray.
function radiobutton_mapeamentoGray_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_mapeamentoGray (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if get(handles.radiobutton_mapeamentoGray,'value')==0
    set(handles.radiobutton_mapeamentoGray,'value',1)
end
% Hint: get(hObject,'Value') returns toggle state of radiobutton_mapeamentoGray
set(handles.radiobutton_mapeamentoPadrao,'value',0)
guidata(hObject,handles)



% --- Executes on button press in radiobutton_mapeamentoPadrao.
function radiobutton_mapeamentoPadrao_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_mapeamentoPadrao (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if get(handles.radiobutton_mapeamentoPadrao,'value')==0
    set(handles.radiobutton_mapeamentoPadrao,'value',1)
end
% Hint: get(hObject,'Value') returns toggle state of radiobutton_mapeamentoPadrao
set(handles.radiobutton_mapeamentoGray,'value',0)
guidata(hObject,handles)
