%
%                            Copyright 2011 Zilmar de Souza Junior,
%						                    Marcos Moecke 
%
%
%
%    modulo_voz_v1_0 is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    modulo_voz_v1_0 is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with modulo_voz_v1_0. If not, see <http://www.gnu.org/licenses/>.
%

%% Funoes geradas pelo Matlab
function varargout = modulo_voz_v1_0(varargin)
% MODULO_VOZ_V1_0 M-file for modulo_voz_v1_0.fig
%      MODULO_VOZ_V1_0, by itself, creates a new MODULO_VOZ_V1_0 or raises the existing
%      singleton*.
%
%      H = MODULO_VOZ_V1_0 returns the handle to a new MODULO_VOZ_V1_0 or the handle to
%      the existing singleton*.
%
%      MODULO_VOZ_V1_0('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MODULO_VOZ_V1_0.M with the given input arguments.
%
%      MODULO_VOZ_V1_0('Property','Value',...) creates a new MODULO_VOZ_V1_0 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before modulo_voz_v1_0_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to modulo_voz_v1_0_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help modulo_voz_v1_0

% Last Modified by GUIDE v2.5 15-Jan-2011 10:16:55

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @modulo_voz_v1_0_OpeningFcn, ...
                   'gui_OutputFcn',  @modulo_voz_v1_0_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before modulo_voz_v1_0 is made visible.
function modulo_voz_v1_0_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to modulo_voz_v1_0 (see VARARGIN)

% Choose default command line output for modulo_voz_v1_0
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes modulo_voz_v1_0 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = modulo_voz_v1_0_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


%% Funes especficas do Mdulo abaixo:
% --- Executes on button press in PBGravar.
function PBGravar_Callback(hObject, eventdata, handles)
% hObject    handle to PBGravar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%-------------------------------------------------------------------------
% CASO SEJA NECESSRIO ALTERAR O DISPOSITIVO PADRO EXECUTE O COMANDO
% DAQHWINFO() E INSIRA O DIPOSITIVO PRESENTE NO CAMPO InstalledAdapters NA
% LINHA ABAIXO
ai = analoginput('winsound'); %criao do objeto e definio do dispositivo de entrada
%--------------------------------------------------------------------------

%cria um canal de udio para o objeto:
addchannel(ai, 1);

%recebe o tempo total de gravao
prompt = {'Insira o tempo de gravao:'};
titulo_janela = 'Tempo de gravao';
num_linhas = 1;
default={'5'};
t_gravacao = inputdlg(prompt,titulo_janela,num_linhas,default);
t_gravacao = str2double(cat(2,t_gravacao{:}));
handles.metricdata.t_gravacao = t_gravacao;

%define taxa de amostragem e o perodo de amostragem:
ai.SampleRate = 8000; %taxa de amostragem
ai.SamplesPerTrigger = t_gravacao*ai.SampleRate;
ai.TriggerType = 'Immediate';

%inicia a gravao:
start(ai)

%barra de gravao
tic;
wt = waitbar(0,'Gravando...');
while (toc < t_gravacao)
    waitbar(toc/t_gravacao);
end    
close(wt)


%salva as informaoes nos vetores d e t:
[sinal_voz,t] = getdata(ai);

axes(handles.axes1)
plot(t,sinal_voz)
title('Sinal de Voz')
xlabel('Tempo(s)')
ylabel('Amplitude')
handles.metricdata.sinal_voz = sinal_voz;
guidata(hObject, handles);



% --- Executes on button press in PBOuvir.
function PBOuvir_Callback(hObject, eventdata, handles)
% hObject    handle to PBOuvir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
sinal_voz = handles.metricdata.sinal_voz;

%-------------------------------------------------------------------------
% CASO SEJA NECESSRIO ALTERAR O DISPOSITIVO PADRO EXECUTE O COMANDO
% DAQHWINFO() E INSIRA O DIPOSITIVO PRESENTE NO CAMPO InstalledAdapters NA
% LINHA ABAIXO
ao = analogoutput('winsound');
%-------------------------------------------------------------------------

addchannel(ao, 1);
putdata(ao, sinal_voz);
set(ao, 'TriggerType', 'Immediate');
start(ao);

% --- Executes on button press in PBFft.
function PBFft_Callback(hObject, eventdata, handles)
% hObject    handle to PBFft (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%importa os dados necessrios
sinal_voz = handles.metricdata.sinal_voz;
t_gravacao = handles.metricdata.t_gravacao;

%cria uma nova figura
figure;

%tamanho do vetor do sinal de voz
n_voz = max(size(sinal_voz)); 

sinal_fft = abs(fft(sinal_voz))/(n_voz/2); 
%parte positiva da potencia do sinal
sinal_fft = sinal_fft(1:n_voz/2).^2; 

%determina a frequencia correspondente em Hz
freq = [0:n_voz/2-1]/t_gravacao; 

%plot com escala logartmica
semilogy(freq,sinal_fft);
grid on;
title('Sinal de voz no domnio da frequencia')
ylabel('Potncia do sinal')
xlabel('Frequncia (Hz)')



