%
%                            Copyright 2011 Zilmar de Souza Junior,
%						                    Marcos Moecke 
%
%
%
%    ModuloAMFMCodigos is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    ModuloAMFMCodigos is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with ModuloAMFMCodigos. If not, see <http://www.gnu.org/licenses/>.
%



function varargout = ModuloAMFMCodigos(varargin)
% MODULOAMFMCODIGOS M-file for ModuloAMFMCodigos.fig
%      MODULOAMFMCODIGOS, by itself, creates a new MODULOAMFMCODIGOS or raises the existing
%      singleton*.
%
%      H = MODULOAMFMCODIGOS returns the handle to a new MODULOAMFMCODIGOS or the handle to
%      the existing singleton*.
%
%      MODULOAMFMCODIGOS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MODULOAMFMCODIGOS.M with the given input arguments.
%
%      MODULOAMFMCODIGOS('Property','Value',...) creates a new MODULOAMFMCODIGOS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ModuloAMFMCodigos_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ModuloAMFMCodigos_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ModuloAMFMCodigos

% Last Modified by GUIDE v2.5 15-Sep-2014 20:22:45

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @ModuloAMFMCodigos_OpeningFcn, ...
    'gui_OutputFcn',  @ModuloAMFMCodigos_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
primeiraExecucao = 1;
% addpath(fullfile('.','lib'));



% --- Executes just before ModuloAMFMCodigos is made visible.
function ModuloAMFMCodigos_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ModuloAMFMCodigos (see VARARGIN)

% Choose default command line output for ModuloAMFMCodigos
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);

popupmenuModulo_Callback(hObject, eventdata, handles);

% UIWAIT makes ModuloAMFMCodigos wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ModuloAMFMCodigos_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function c_int_Callback(hObject, eventdata, handles)
% hObject    handle to c_int (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_int as text
%        str2double(get(hObject,'String')) returns contents of c_int as a double
intervalo = str2double(get(hObject, 'String'));
if isnan(intervalo)
    set(hObject, 'String', 0);
    errordlg('Intervalo inv�lido','Error');
end
% Save the new intervalo value
handles.metricdata.intervalo = intervalo;
guidata(hObject,handles)


% --- Executes during object creation, after setting all properties.
function c_int_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_int (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function c_vp_Callback(hObject, eventdata, handles)
% hObject    handle to c_vp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_vp as text
%        str2double(get(hObject,'String')) returns contents of c_vp as a double
vpico = str2double(get(hObject, 'String'));
if isnan(vpico)
    set(hObject, 'String', 0);
    errordlg('Intervalo inv�lido','Error');
end
% Save the new intervalo value
set(handles.slider_vp,'Value',vpico)
handles.metricdata.vpico = vpico;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function c_vp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_vp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function c_freqp_Callback(hObject, eventdata, handles)
% hObject    handle to c_freqp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_freqp as text
%        str2double(get(hObject,'String')) returns contents of c_freqp as a double
freqp = str2double(get(hObject, 'String'));
if isnan(freqp)
    set(hObject, 'String', 0);
    errordlg('Valor inv�lido','Error');
end
% Save the new intervalo value
set(handles.slider_w,'Value',freqp)
handles.metricdata.freqp = freqp;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function c_freqp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_freqp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function c_mi_Callback(hObject, eventdata, handles)
% hObject    handle to c_mi (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_mi as text
%        str2double(get(hObject,'String')) returns contents of c_mi as a double
m = str2double(get(hObject, 'String'));
if isnan(m)
    set(hObject, 'String', 0);
    errordlg('Intervalo inv�lido','Error');
end
% Save the new intervalo value
set(handles.slider_theta,'Value',m)
handles.metricdata.m = m;
guidata(hObject,handles)
% --- Executes during object creation, after setting all properties.
function c_mi_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_mi (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in b_plot.
function b_plot_Callback(hObject, eventdata, handles, modulante)
% hObject    handle to b_plot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% c_mi_Callback(c_mi, eventdata, handles)
% c_freqp_Callback(c_freqp, eventdata, handles)

%Inicializa_Valores_Interface

handles.metricdata.m = str2double(get(handles.c_mi, 'String'));
handles.metricdata.freqp = str2double(get(handles.c_freqp, 'String'));
handles.metricdata.vpico = str2double(get(handles.c_vp, 'String'));
handles.metricdata.fv = str2double(get(handles.c_deltafv, 'String'));
if (isfield(handles,'modulante')==1)
    switch get(handles.popupmenuModulo,'Value')
      case 1
          [handles.modParaSound,handles.sParaSound] = Atualiza_Interface_am(handles);
          guidata(hObject,handles)
        case 2
          [handles.modParaSound,handles.sParaSound] = Atualiza_Interface_fm(handles);
          guidata(hObject,handles)
        case 3
          [handles.modParaSound,handles.sParaSound] = Atualiza_Interface_amdsbsc(handles);
          guidata(hObject,handles)
        case 4
          [handles.modParaSound,handles.sParaSound] = Atualiza_Interface_amssb(handles);
          guidata(hObject,handles)
        case 5
          [handles.modParaSound,handles.sParaSound] = Atualiza_Interface_amvsb(handles);
          guidata(hObject,handles)
    end
else
    handles.modulante=1;
    handles.freqm=10;
    handles.vmodulante=1;
    handles.bsinc=1;
    guidata(hObject,handles)
    b_plot_Callback(handles.b_plot, eventdata, handles)
end
guidata(hObject,handles)




% --- Executes during object creation, after setting all properties.
function b_plot_CreateFcn(hObject, eventdata, handles)
% hObject    handle to b_plot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on key press with focus on b_plot and none of its controls.
function b_plot_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to b_plot (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
Atualiza_Interface_am(handles)



function c_amos_Callback(hObject, eventdata, handles)
% hObject    handle to c_amos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_amos as text
%        str2double(get(hObject,'String')) returns contents of c_amos as a double
c_amos = str2double(get(hObject, 'String'));
if isnan(c_amos)
    set(hObject, 'String', 0);
    errordlg('Valor inv�lido','Error');
end
% Save the new c_amos value
handles.metricdata.c_amos = c_amos;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function c_amos_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_amos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end







function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double


% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on slider movement.
function slider_w_Callback(hObject, eventdata, handles)
% hObject    handle to slider_w (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

% Get the new value for the Kf Gain from the slider.
novo_w = get(hObject, 'Value');
% Set the value of the KfCurrentValue to the new value
% set by slider.
set(handles.c_freqp,'String',novo_w)
handles.metricdata.freqp = novo_w;
guidata(hObject,handles)
b_plot_Callback(handles.b_plot, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function slider_w_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_w (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_vp_Callback(hObject, eventdata, handles)
% hObject    handle to slider_vp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
% Get the new value for the Kf Gain from the slider.
novo_vp = get(hObject, 'Value');
% Set the value of the KfCurrentValue to the new value
% set by slider.
set(handles.c_vp,'String',novo_vp)
handles.metricdata.vpico = novo_vp;
guidata(hObject,handles)
b_plot_Callback(handles.b_plot, eventdata, handles)



% --- Executes during object creation, after setting all properties.
function slider_vp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_vp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_int_Callback(hObject, eventdata, handles)
% hObject    handle to slider_int (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
% Get the new value for the Kf Gain from the slider.
novo_i = get(hObject, 'Value');
% Set the value of the KfCurrentValue to the new value
% set by slider.
set(handles.c_int,'String',novo_i)
handles.metricdata.intervalo = novo_i;
guidata(hObject,handles)
Atualiza_Interface_am(handles)


% --- Executes during object creation, after setting all properties.
function slider_int_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_int (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_theta_Callback(hObject, eventdata, handles)
% hObject    handle to slider_theta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
% Get the new value for the Kf Gain from the slider.
novo_theta = get(hObject, 'Value');
% Set the value of the KfCurrentValue to the new value
% set by slider.
set(handles.c_mi,'String',novo_theta)
handles.metricdata.m = novo_theta;
guidata(hObject,handles)
b_plot_Callback(handles.b_plot, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function slider_theta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_theta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



% --- Executes on slider movement.





% --- Executes on slider movement.
function slider_fs_Callback(hObject, eventdata, handles)
% hObject    handle to slider_fs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
% Get the new value for the Kf Gain from the slider.
novo_fs = get(hObject, 'Value');
% Set the value of the KfCurrentValue to the new value
% set by slider.
set(handles.c_amos,'String',novo_fs)
handles.metricdata.c_amos = novo_fs;
guidata(hObject,handles)
b_plot_Callback(handles.b_plot, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function slider_fs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_fs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --------------------------------------------------------------------
function Untitled_1_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function c_eval_Callback(hObject, eventdata, handles)
% hObject    handle to c_eval (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_eval as text
%        str2double(get(hObject,'String')) returns contents of c_eval as a double
st_ev = get(hObject, 'String');
% Save the new intervalo value
intervalo = handles.metricdata.intervalo;
t=[-(intervalo):0.01:intervalo];
campoeval=eval(st_ev);
handles.metricdata.campoeval = campoeval;
guidata(hObject,handles)


% --- Executes during object creation, after setting all properties.
function c_eval_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_eval (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in b_eval.
function b_eval_Callback(hObject, eventdata, handles)
% hObject    handle to b_eval (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
intervalo = handles.metricdata.intervalo;
t=[-(intervalo):0.01:intervalo];
s = handles.metricdata.campoeval;
plot(handles.axes_port,t,s);




% --------------------------------------------------------------------
function zoomx_OffCallback(hObject, eventdata, handles)
% hObject    handle to zoomx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom on;

% --------------------------------------------------------------------
function zoomx_OnCallback(hObject, eventdata, handles)
% hObject    handle to zoomx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom xon;


% --------------------------------------------------------------------
function zoomy_OffCallback(hObject, eventdata, handles)
% hObject    handle to zoomy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom on;

% --------------------------------------------------------------------
function zoomy_OnCallback(hObject, eventdata, handles)
% hObject    handle to zoomy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom yon;


% --------------------------------------------------------------------
function expande_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to expande (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
prompt = {'Qual sinal expandir?'};
titulo_janela = 'Expandir';
num_linhas = 1;
default={'1'};
qualsinal = inputdlg(prompt,titulo_janela,num_linhas,default);
qualsinal = str2double(cat(2,qualsinal{:}));
switch qualsinal
    case 1
        set(handles.axes_port,'XLim',[-1 1])
    case 2
        set(handles.axes_sign,'XLim',[-1 1])
    case 3
        set(handles.axes_mod,'XLim',[0 Inf])
end

% --- Executes when selected object is changed in uipanelMetodo.
function uipanelMetodo_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanelMetodo
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
% Controle dos bot�es
if(hObject == handles.radiobuttonManual)
    set(handles.uipanelVoz,'visible','off')
    set(handles.uipanelModulante,'visible','on')
else
    set(handles.uipanelVoz,'visible','on')
    set(handles.uipanelModulante,'visible','off')
    
    
end


% --- Executes on button press in pushbuttonGravar.
function pushbuttonGravar_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonGravar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Gravar voz
%cria��o do objeto e defini��o do dispositivo de entrada:
get(hObject);
ai = analoginput('winsound');

%cria um canal de �udio para o objeto:
addchannel(ai, 1);

%define taxa de amostragem e o per�odo de amostragem:
t_gravacao = 4; %segundos
%verifica a frequencia minima de amostragem da placa.
ai.SampleRate = 8000; %cell2mat(daqhwinfo(ai,{'MinSampleRate'}));
ai.SamplesPerTrigger = ai.SampleRate*t_gravacao;
ai.TriggerType = 'Immediate';

%inicia a grava��o:
start(ai);tic;
%msgbox('Grava��o em processo! Aguarde 3 segundos e confirme.','Gravando','warn')
wt = waitbar(0,'Gravando...');
while (toc < t_gravacao)
    waitbar(toc/t_gravacao);
end

close(wt)

%salva as informa�oes nos vetores d e t:
[d,t] = getdata(ai);
handles.metricdata.d = d;
handles.metricdata.t = t;
guidata(hObject,handles)
Atualiza_Interface_am(handles)

% --- Executes on button press in pushbuttonOuvir.
function pushbuttonOuvir_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonOuvir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Reproduzir
get(hObject);
d = handles.metricdata.d;
ao = analogoutput('winsound');
addchannel(ao, 1);
putdata(ao, d);
set(ao, 'TriggerType', 'Immediate');
start(ao)


% --- Executes on selection change in popupmenuModulo.
function popupmenuModulo_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuModulo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenuModulo contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuModulo
modulo=get(handles.popupmenuModulo, 'Value');
% 1 - AM-Convencional; 2 - FM; 3 - AM-DSB-SC, 4 - AM-SSB-SC, 5 - AM-VSB

if (modulo==1)
    set(handles.uipanelPortadora,'visible','on')
    set(handles.uipanelPrincipal,'visible','on')
    set(handles.uipanelIndice,'visible','on')
    set(handles.slider_theta,'visible','on')
    set(handles.c_mi,'visible','on')
    set(handles.mi,'visible','on')
    set(handles.Beta,'visible','off')
    set(handles.uipanelBandaLateral,'visible','off')
    set(handles.uipanelFiltroVSB,'visible','off')
elseif (modulo == 2)
    set(handles.uipanelPortadora,'visible','on')
    set(handles.uipanelPrincipal,'visible','on')
    set(handles.uipanelIndice,'visible','on')
    set(handles.slider_theta,'visible','on')
    set(handles.c_mi,'visible','on')
    set(handles.mi,'visible','off')
    set(handles.Beta,'visible','on')
    set(handles.uipanelBandaLateral,'visible','off')
    set(handles.uipanelFiltroVSB,'visible','off')
elseif (modulo == 4)
    set(handles.uipanelPortadora,'visible','on')
    set(handles.uipanelPrincipal,'visible','on')
    set(handles.uipanelIndice,'visible','off')
    set(handles.slider_theta,'visible','off')
    set(handles.c_mi,'visible','off')
    set(handles.mi,'visible','off')
    set(handles.Beta,'visible','off')
    set(handles.uipanelBandaLateral,'visible','on')
    set(handles.uipanelFiltroVSB,'visible','off')
elseif (modulo==5)
    set(handles.uipanelPortadora,'visible','on')
    set(handles.uipanelPrincipal,'visible','on')
    set(handles.uipanelIndice,'visible','off')
    set(handles.slider_theta,'visible','off')
    set(handles.c_mi,'visible','off')
    set(handles.mi,'visible','off')
    set(handles.Beta,'visible','off')
    set(handles.uipanelBandaLateral,'visible','off')
    set(handles.uipanelFiltroVSB,'visible','on')
    set(handles.slider_fv,'visible','on')
else
    set(handles.uipanelPortadora,'visible','on')
    set(handles.uipanelPrincipal,'visible','on')
    set(handles.uipanelIndice,'visible','off')
    set(handles.slider_theta,'visible','off')
    set(handles.c_mi,'visible','off')
    set(handles.mi,'visible','off')
    set(handles.Beta,'visible','off')
    set(handles.uipanelBandaLateral,'visible','off')
    set(handles.uipanelFiltroVSB,'visible','off')
end

% --- Executes during object creation, after setting all properties.
function popupmenuModulo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuModulo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function uipanelModulo_Callback(hObject, eventdata, handles)
% hObject    handle to uipanelModulo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function c_beta_Callback(hObject, eventdata, handles)
% hObject    handle to c_beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_beta as text
%        str2double(get(hObject,'String')) returns contents of c_beta as a double
beta = str2double(get(hObject, 'String'));
if isnan(beta)
    set(hObject, 'String', 0);
    errordlg('Valor inv�lido','Error');
end
% Save the new intervalo value
set(handles.slider_beta,'Value',beta)
handles.metricdata.beta = beta;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function c_beta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_beta_Callback(hObject, eventdata, handles)
% hObject    handle to slider_beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
novo_beta = get(hObject, 'Value');
%novo_beta = str2double(get(handles.c_beta,'String'));
% Set the value of the KfCurrentValue to the new value
% set by slider.
set(handles.c_beta,'String',novo_beta)
handles.metricdata.beta = novo_beta;
guidata(hObject,handles)
b_plot_Callback(handles.b_plot, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function slider_beta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on selection change in popupmenuModulante.
function popupmenuModulante_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuModulante (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuModulante contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuModulante


% --- Executes during object creation, after setting all properties.
function popupmenuModulante_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuModulante (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonModulante.
function pushbuttonModulante_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonModulante (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[handles.modulante,handles.freqm,handles.vmodulante,handles.bsinc,handles.fullPath]=MenuModulante;
guidata(hObject, handles);
b_plot_Callback(handles.b_plot, eventdata, handles);

% --- Executes on slider movement.
function slider_fv_Callback(hObject, eventdata, handles)
% hObject    handle to slider_fv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
novo_fv = get(hObject, 'Value');
% Set the value of the KfCurrentValue to the new value
% set by slider.
set(handles.c_deltafv,'String',novo_fv)
handles.metricdata.fv = novo_fv;
guidata(hObject,handles)
b_plot_Callback(handles.b_plot, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function slider_fv_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_fv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function c_deltafv_Callback(hObject, eventdata, handles)
% hObject    handle to c_beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_beta as text
%        str2double(get(hObject,'String')) returns contents of c_beta as a double
fv = str2double(get(hObject, 'String'));
if isnan(fv)
    set(hObject, 'String', 0);
    errordlg('Valor inv�lido','Error');
end
% Save the new intervalo value
set(handles.slider_fv,'Value',fv)
handles.metricdata.fv = fv;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function c_deltafv_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_deltafv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function uipanelFiltroVSB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanelFiltroVSB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function Beta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in b_ouvirModulante.
function b_ouvirModulante_Callback(hObject, eventdata, handles)
fs = 1e5;
if isfield(handles,'modParaSound')==1
    splay = resample(handles.modParaSound, 44100, fs);
    sound(splay, 44100);
end
% hObject    handle to b_ouvirModulante (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in b_ouvirModulado.
function b_ouvirModulado_Callback(hObject, eventdata, handles)
fs = 1e5;
if isfield(handles,'sParaSound')==1
    splay = resample(handles.sParaSound, 44100, fs);
    sound(splay, 44100);
end
% hObject    handle to b_ouvirModulado (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
