%
%                            Copyright 2011 Zilmar de Souza Junior,
%						                    Marcos Moecke 
%
%
%
%    ModuloBasico_v1 is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    ModuloBasico_v1 is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with ModuloBasico_v1. If not, see <http://www.gnu.org/licenses/>.
%


%% Funes Geradas automaticamente pelo TCC
function varargout = ModuloBasico_v1(varargin)
% MODULOBASICO_V1 M-file for ModuloBasico_v1.fig
%      MODULOBASICO_V1, by itself, creates a new MODULOBASICO_V1 or raises the existing
%      singleton*.
%
%      H = MODULOBASICO_V1 returns the handle to a new MODULOBASICO_V1 or the handle to
%      the existing singleton*.
%
%      MODULOBASICO_V1('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MODULOBASICO_V1.M with the given input arguments.
%
%      MODULOBASICO_V1('Property','Value',...) creates a new MODULOBASICO_V1 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ModuloBasico_v1_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ModuloBasico_v1_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ModuloBasico_v1

% Last Modified by GUIDE v2.5 24-Nov-2014 20:38:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ModuloBasico_v1_OpeningFcn, ...
                   'gui_OutputFcn',  @ModuloBasico_v1_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ModuloBasico_v1 is made visible.
function ModuloBasico_v1_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ModuloBasico_v1 (see VARARGIN)

% Choose default command line output for ModuloBasico_v1
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ModuloBasico_v1 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ModuloBasico_v1_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%--------- Funo que recebe o valor de pico da interface ----------------%
function ValorPico_Callback(hObject, eventdata, handles)
% hObject    handle to ValorPico (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ValorPico as text
%        str2double(get(hObject,'String')) returns contents of ValorPico as a double
valPico = str2double(get(hObject, 'String'));
if isnan(valPico)
    set(hObject, 'String', 0);
    errordlg('Intervalo invlido','Error');
end
% Save the new intervalo value
handles.metricdata.valPico = valPico;
set(handles.slider_pico,'Value',valPico)
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function ValorPico_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ValorPico (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%--------- Funo que recebe o valor da frequencia do sinal ----------------%
function FreqSinal_Callback(hObject, eventdata, handles)
% hObject    handle to FreqSinal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FreqSinal as text
%        str2double(get(hObject,'String')) returns contents of FreqSinal as a double
freqSinal = str2double(get(hObject, 'String'));
if isnan(freqSinal)
    set(hObject, 'String', 0);
    errordlg('Intervalo invlido','Error');
end
% Save the new intervalo value
handles.metricdata.freqSinal = freqSinal;
set(handles.slider_freqSinal,'Value',freqSinal)
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function FreqSinal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FreqSinal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%--------- Funo do boto Plot-------------%
% --- Executes on button press in BotaoPlot.
function BotaoPlot_Callback(hObject, eventdata, handles)
% hObject    handle to BotaoPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.metricdata.freqAmostragem = str2double(get(handles.FreqAmostragem,'String'));
Atualiza_ModuloBasico(handles)

%--------- Funo que recebe o valor da frequencia de amostragem -------------%
function FreqAmostragem_Callback(hObject, eventdata, handles)
% hObject    handle to FreqAmostragem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FreqAmostragem as text
%        str2double(get(hObject,'String')) returns contents of FreqAmostragem as a double
freqAmostragem = str2double(get(hObject, 'String'));
if isnan(freqAmostragem)
    set(hObject, 'String', 0);
    errordlg('Intervalo invlido','Error');
end
% Save the new intervalo value
handles.metricdata.freqAmostragem = freqAmostragem;
set(handles.slider_freqAmostragem,'Value',freqAmostragem)
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function FreqAmostragem_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FreqAmostragem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%--------- Funo da barra de rolagem para valor de pico ---------------%
% --- Executes on slider movement.
function slider_pico_Callback(hObject, eventdata, handles)
% hObject    handle to slider_pico (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
valor = get(hObject, 'Value');
%novo_fm = str2double(get(handles.c_freqm,'String'));
% Set the value of the KfCurrentValue to the new value
% set by slider.
set(handles.ValorPico,'String',valor)
handles.metricdata.valPico = valor;
guidata(hObject,handles)
BotaoPlot_Callback(handles.BotaoPlot, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function slider_pico_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_pico (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%--------- Funo da barra de rolagem para frequencia do sinal ---------------%
% --- Executes on slider movement.
function slider_freqSinal_Callback(hObject, eventdata, handles)
% hObject    handle to slider_freqSinal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
valor = get(hObject, 'Value');
%novo_fm = str2double(get(handles.c_freqm,'String'));
% Set the value of the KfCurrentValue to the new value
% set by slider.
set(handles.FreqSinal,'String',valor)
handles.metricdata.freqSinal = valor;
guidata(hObject,handles)
BotaoPlot_Callback(handles.BotaoPlot, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function slider_freqSinal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_freqSinal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%--------- Funo da barra de rolagem para frequencia do amostragem --------------%
% --- Executes on slider movement.
function slider_amostragem_Callback(hObject, eventdata, handles)
% hObject    handle to slider_amostragem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
valor = get(hObject, 'Value');
%novo_fm = str2double(get(handles.c_freqm,'String'));
% Set the value of the KfCurrentValue to the new value
% set by slider.
set(handles.FreqAmostragem,'String',valor)
handles.metricdata.freqAmostragem = valor;
guidata(hObject,handles)
BotaoPlot_Callback(handles.BotaoPlot, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function slider_amostragem_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_amostragem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on selection change in PopMenuFuncao.
function PopMenuFuncao_Callback(hObject, eventdata, handles)
% hObject    handle to PopMenuFuncao (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns PopMenuFuncao contents as cell array
%        contents{get(hObject,'Value')} returns selected item from PopMenuFuncao


% --- Executes during object creation, after setting all properties.
function PopMenuFuncao_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PopMenuFuncao (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function CampoEval_Callback(hObject, eventdata, handles)
% hObject    handle to CampoEval (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of CampoEval as text
%        str2double(get(hObject,'String')) returns contents of CampoEval as a double
campoEval = get(hObject, 'String');
handles.metricdata.campoEval = campoEval;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function CampoEval_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CampoEval (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in BotaoOkEval.
function BotaoOkEval_Callback(hObject, eventdata, handles)
% hObject    handle to BotaoOkEval (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.metricdata.valPico = str2double(get(handles.ValorPico, 'String'));
handles.metricdata.freqAmostragem = str2double(get(handles.FreqAmostragem,'String'));
handles.metricdata.freqSinal = str2double(get(handles.FreqSinal,'String'));
EvalModulo(handles)


% --------------------------------------------------------------------
function zoomx_OffCallback(hObject, eventdata, handles)
% hObject    handle to zoomx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom on;

% --------------------------------------------------------------------
function zoomx_OnCallback(hObject, eventdata, handles)
% hObject    handle to zoomx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom xon;


% --------------------------------------------------------------------
function zoomy_OffCallback(hObject, eventdata, handles)
% hObject    handle to zoomy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom on;

% --------------------------------------------------------------------
function zoomy_OnCallback(hObject, eventdata, handles)
% hObject    handle to zoomy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
zoom yon;


% --- Executes on button press in pushbuttonSinal.
function pushbuttonSinal_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonSinal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[handles.tipoSinal,handles.freqSinal,handles.vSinal,handles.bsinc,handles.fullPath]=MenuModulante;
% while handles.tipoSinal==6
%     uiwait(errordlg('Uso de arquivos de som no est disponvel para este mdulo','Erro','modal'));
%     [handles.tipoSinal,handles.freqSinal1,handles.vSinal1,handles.bsinc1,handles.fullPath1]=MenuModulante;
% end
guidata(hObject,handles)
