function [PSD] = definePSD(codificacao,f,Tb,amp)

amp=1/amp^2;

switch codificacao
    case 1  % AMI
       PSD = Tb * sinc(Tb*f).^2 .* sin(pi*Tb*f).^2;
    case 2  % Polar NRZ
       PSD = Tb * sinc(f*Tb).^2;
    case 3  % Polar RZ
       PSD=((amp*Tb)/16)*((sinc((f*Tb)/2)).^2);
    case 4  % Manchester
       PSD=((amp*Tb)/4)*((sinc((f*Tb)/2)).^2).*((sin((pi*f*Tb)/2)).^2);
    case 5  % Unipolar NRZ
        impulso=f*0;
        impulso(length(impulso)/2+1)=amp;
        PSD=((amp*Tb))*(sinc(f*Tb).^2)+(impulso/4);
    case 6  % Unipolar RZ
        i=1:length(f);
        impulso=cumsum(100+i/Tb);
        PSD=((amp*Tb))*(sinc(f*Tb).^2).*(impulso);
    case 7
    case 8
    case 9
    case 10
end
